var _ = require("lodash");
var Objects = require("convenience").Objects;

function PluginHelper (pluginInfo)
{
    var t = this;
    t.services = _(Objects.toJS(pluginInfo.getServices())).map(function (service) {
        return [service.name, function (args) {
            return Objects.toJS(service['invoke(java.util.Map)'](args || {}));
        }];
    }).fromPairs().value();
    
    t.settings = function settings (arg)
    {
        if (arg)
        {
            return t.services['settings.set'](arg);
        }
        
        return t.services['settings.get']();
    };
}

module.exports = PluginHelper;