/* global org */
var _ = require("underscore"),
    verbs = ["GET", "POST", "PUT", "DELETE"];

function Router (options)
{
    var rest = new org.webbitserver.rest.Rest(options.server),
        t = this;
    
    _(verbs).each(function (verb) {
        t[verb.toLowerCase()] = function (path) {
            for (var i = 1; i < arguments.length; i++)
            {
                rest[verb](path, handler(arguments[i]));
            }
            
            return t;
        };
    });
}

function handler (fn)
{
    return new org.webbitserver.HttpHandler({
        handleHttpRequest: function (req, res) {
            fn(new Request(req), new Response(res));
        }
    });
}

function Request (req)
{
    
}

function Response (res)
{
    
}

module.exports = {
    Router: Router,
    handler: handler,
    Request: Request,
    Response: Response
};